import java.io.File;
import java.util.Scanner;

import comp202.fall2007.a5.loader.ConsoleDisplayListener;
import comp202.fall2007.a5.loader.SongLoader;

public class A5TestTemplate {
	public static void main(String[] args) {
		MusicCollectionBuilder builder;
		ConsoleDisplayListener consoleDisplay;
		MusicCollection collection;
		Scanner keyboard;
		SongLoader loader;
		String path;
		File rootDirectory;

		// Set up keyboard input
		keyboard = new Scanner(System.in);
		
		// Ask the user to enter the root directory where his / her MP3 files
		// are located
		System.out.print("Enter the directory where your music files are "
				+ "stored: ");
		path = keyboard.nextLine();
		rootDirectory = new File(path);

		// Load the files from the disk
		builder = new MusicCollectionBuilder();
		consoleDisplay = new ConsoleDisplayListener(rootDirectory);
		
		loader = new SongLoader();
		loader.addListener(builder);
		loader.addListener(consoleDisplay);
		loader.load(rootDirectory);

		// Retrieve the library
		collection = builder.getCollection();
		
		// Add your code here
	}
}
