import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;

public class COMP202MusicPlayerInstaller {
	public static void main(String[] args) {
		PrintStream scriptStream;
		String operatingSystem;
		String fileSeparator;
		String command;
		String classPath;
		String fullCommand;
		File scriptFile;
		File workingDirectory;
		File libDirectory;
		File[] libraries;
		boolean isWindows;

		operatingSystem = System.getProperty("os.name");
		operatingSystem = operatingSystem.toUpperCase();
		isWindows = (operatingSystem.indexOf("WINDOWS") != -1);

		workingDirectory = new File(System.getProperty("user.dir"));
		libDirectory = new File(workingDirectory, "lib");

		libraries = libDirectory.listFiles();
		classPath = "-cp ";
		for (File library : libraries) {
			classPath = classPath + "\"" + library.getAbsolutePath() + "\""
					+ System.getProperty("path.separator");
		}
		classPath = classPath + "\"" + workingDirectory.getAbsolutePath()
				+ "\"";

		fileSeparator = System.getProperty("file.separator");
		command = "\"" + System.getProperty("java.home") + fileSeparator
				+ "bin" + fileSeparator + "java" + (isWindows ? "w" : "")
				+ "\"";
		fullCommand = command + " " + classPath + " COMP202MusicPlayer"
				+ (!isWindows ? " &" : "");

		scriptFile = new File(workingDirectory, "comp202musicplayer"
				+ (isWindows ? ".bat" : ""));
		try {
			scriptStream = new PrintStream(scriptFile);
		} catch (FileNotFoundException exception) {
			System.err.println("Could not generate run script file "
					+ scriptFile.getAbsolutePath());
			return;
		}

		if (!isWindows) {
			scriptStream.println("#!/bin/sh");
		} else {
			scriptStream.println("@echo off");
		}
		scriptStream.println();
		scriptStream.println(fullCommand);
		scriptStream.close();

		if (!isWindows) {
			try {
				Runtime.getRuntime().exec(
						"chmod +x " + scriptFile.getAbsolutePath());
			} catch (IOException exception) {
				System.err
						.println("Could not give execute permission to run script file "
								+ scriptFile.getAbsolutePath());
				System.err
						.println("Please do this manually by typing (or copying/pasting) the following command on the terminal: ");
				System.err.println("chmod +x " + scriptFile.getAbsolutePath());
			}
		}
	}
}
