import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.NoSuchElementException;

import comp202.fall2007.a5.comparator.SongComparator;
import comp202.fall2007.a5.util.Song;

public interface PlaylistComponent {
	public static final int EMPTY_PLAYLIST = IteratedPlaylist.EMPTY_PLAYLIST;

	public void add(int index, Song song);

	public boolean add(Song song);

	public boolean addAll(ArrayList<Song> songList);

	public boolean addAll(Playlist playList);

	public boolean addAll(Song[] songArray);

	public void clear();

	public Song get(int index);

	public int getCurrentPosition();

	public int getPlaylistSize();

	public boolean hasNextTrack();

	public boolean hasPreviousTrack();

	public boolean isEmpty();

	public ArrayList<String> load(File path, MusicCollection collection)
			throws IOException;

	public void moveDown(int index, int numberPositions);

	public void moveToNextTrack() throws NoSuchElementException;

	public void moveToPreviousTrack() throws NoSuchElementException;

	public void moveUp(int index, int numberPositions);

	public Song removeSong(int index);

	public void save(File path) throws IOException;

	public void setCurrentPosition(int current)
			throws IndexOutOfBoundsException;

	public void sort(SongComparator comparator);
}
