package comp202.fall2007.a5.comparator;

import java.io.File;

abstract class ComparatorOrder {
	private String symbol;

	public static final ComparatorOrder ASCENDING = new ComparatorOrder(
			"ascending") {
		public int compareTo(String left, String right) {
			return left.compareTo(right);
		}

		public int compareToIgnoreCase(String left, String right) {
			return left.compareToIgnoreCase(right);
		}

		public int compareTo(int left, int right) {
			return left - right;
		}
		
		public int compareTo(File left, File right) {
			File leftAbsoluteFile;
			File rightAbsoluteFile;
			
			leftAbsoluteFile = left.getAbsoluteFile();
			rightAbsoluteFile = right.getAbsoluteFile();
			return leftAbsoluteFile.compareTo(rightAbsoluteFile);
		}
	};

	public static final ComparatorOrder DESCENDING = new ComparatorOrder(
			"descending") {
		public int compareTo(String left, String right) {
			return right.compareTo(left);
		}

		public int compareToIgnoreCase(String left, String right) {
			return right.compareToIgnoreCase(left);
		}

		public int compareTo(int left, int right) {
			return right - left;
		}
		
		public int compareTo(File left, File right) {
			return right.compareTo(left);
		}
	};

	private ComparatorOrder(String symbol) {
		this.symbol = symbol;
	}

	public abstract int compareTo(String left, String right);

	public abstract int compareToIgnoreCase(String left, String right);

	public abstract int compareTo(int left, int right);
	
	public abstract int compareTo(File left, File right);

	public String toString() {
		return this.symbol;
	}
}