package comp202.fall2007.a5.comparator;

import java.util.ArrayList;

import comp202.fall2007.a5.util.Song;

class MultiComparator extends SongComparator {
	private final ArrayList<SongComparator> subComparators;
	private String textRepresentation;

	private void createTextRepresentation() {
		int size;

		size = this.subComparators.size();
		this.textRepresentation = "";
		for (int i = 0; i < size; i++) {
			this.textRepresentation = this.textRepresentation
					+ this.subComparators.get(i);
			if (i != (size - 1)) {
				this.textRepresentation = this.textRepresentation + ", ";
			}
		}
	}

	public MultiComparator(SongComparator[] subComparators) {
		this.subComparators = new ArrayList<SongComparator>();
		for (int i = 0; i < subComparators.length; i++) {
			if (subComparators[i] != null) {
				this.subComparators.add(subComparators[i]);
			}
		}
		this.createTextRepresentation();
	}

	public MultiComparator(ArrayList<SongComparator> subComparators) {
		this.subComparators = new ArrayList<SongComparator>();
		for (SongComparator subComparator : subComparators) {
			if (subComparator != null) {
				this.subComparators.add(subComparator);
			}
		}
		this.createTextRepresentation();
	}

	public int compareTo(Song left, Song right) {
		SongComparator comparator;
		int result;
		int i;
		int numberComparators;

		i = 0;
		result = 0;
		numberComparators = subComparators.size();
		while ((i < numberComparators) && (result == 0)) {
			comparator = this.subComparators.get(i);
			result = comparator.compareTo(left, right);
			i++;
		}

		return result;
	}

	public String toString() {
		return this.textRepresentation;
	}
}
