package comp202.fall2007.a5.filter;

import comp202.fall2007.a5.util.Song;

abstract class NumberFilter extends SongFilter {
	private final String valueType;
	private int comparisonValue;
	private NumberMatchType matchType;

	private String textRepresentation;

	public NumberFilter(String valueType, int comparisonValue,
			NumberMatchType matchType) {
		this.valueType = valueType;
		this.comparisonValue = comparisonValue;
		this.matchType = matchType;

		this.textRepresentation = this.valueType + " "
				+ this.matchType.toString() + " " + this.comparisonValue;

	}

	public long getComparisonValue() {
		return this.comparisonValue;
	}

	public NumberMatchType getMatchType() {
		return this.matchType;
	}

	protected abstract int getSongValue(Song song);

	public boolean accept(Song song) {
		return this.matchType.match(this.getSongValue(song),
				this.comparisonValue);
	}

	public String toString() {
		return this.textRepresentation;
	}
}