package comp202.fall2007.a5.filter;

import comp202.fall2007.a5.util.Song;

abstract class TextFilter extends SongFilter {
	private final String valueType;
	private String comparisonValue;
	private StringMatchType matchType;
	private boolean ignoreCase;

	private final String textRepresentation;

	public TextFilter(String valueType, String comparisonValue,
			StringMatchType matchType, boolean ignoreCase) {
		this.valueType = valueType;
		this.comparisonValue = comparisonValue;
		this.matchType = matchType;
		this.ignoreCase = ignoreCase;

		this.textRepresentation = this.valueType + " "
				+ this.matchType.toString() + " \"" + this.comparisonValue
				+ "\"";
	}

	public String getComparisonValue() {
		return this.comparisonValue;
	}

	public StringMatchType getMatchType() {
		return this.matchType;
	}
	
	public boolean ignoresCase() {
		return this.ignoreCase;
	}

	protected abstract String getSongValue(Song song);

	public boolean accept(Song song) {
		return this.matchType.match(this.getSongValue(song),
				this.comparisonValue, this.ignoreCase);
	}

	public String toString() {
		return this.textRepresentation;
	}
}
