package comp202.fall2007.a5.loader;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;

import comp202.fall2007.a5.util.Song;

public class FileLoggingListener extends SongLoaderListener {
	private PrintStream outputFile;
	private File rootDirectory;
	private int songCount;

	public FileLoggingListener(File rootDirectory, File logFile)
			throws IOException {
		this.rootDirectory = rootDirectory;
		this.outputFile = new PrintStream(logFile);
		this.songCount = 0;
	}

	public void loadedSong(Song song) {
		this.outputFile.println("- " + song.getArtist() + " - "
				+ song.getAlbum() + " - " + song.getTitle() + " ("
				+ song.getFilePath() + "; " + song.getTrackNumber() + "; "
				+ song.getLength() + ")");
		this.songCount++;
	}

	public void finishedLoading() {
		this.outputFile.println("Loaded " + this.songCount + " songs.");
	}

	public void startedLoading() {
		this.outputFile.println("Loading songs from directory "
				+ this.rootDirectory);
	}

	public void loadingInterrupted() {
		this.outputFile.println("Loading interrupted after loading "
				+ this.songCount + " songs.");
	}
}
