package comp202.fall2007.a5.util;

import java.io.IOException;

/**
 * Signals that a method has attempted to read a file with an incorrect file
 * extension. 
 */
public class IncorrectFileExtensionException extends IOException {
	/**
	 * <p>
	 * Constructs an <code>IncorrectFileExtensionException</code> with
	 * <code>null</code> as its detail message.
	 * </p>
	 */
	public IncorrectFileExtensionException() {
	}

	/**
	 * <p>
	 * Constructs an <code>IncorrectFileExtensionException</code> with the
	 * specified detail message.
	 * </p>
	 * 
	 * @param message
	 *            The detail message (which is saved for later retrieval by the
	 *            <code>Throwable.getMessage()</code> method)
	 */
	public IncorrectFileExtensionException(String message) {
		super(message);
	}

	/**
	 * <p>
	 * Constructs an <code>IncorrectFileNameException</code> with the
	 * specified cause and a detail message of
	 * <code>(cause==null ? null : cause.toString())</code> (which typically
	 * contains the class and detail message of <code>cause</code>). This
	 * constructor is useful for incorrect file extension exceptions that are
	 * little more than wrappers for other throwables.
	 * </p>
	 * 
	 * @param cause
	 *            The cause (which is saved for later retrieval by the
	 *            <code>Throwable.getCause()</code> method). (A
	 *            <code>null</code> value is permitted, and indicates that the
	 *            cause is nonexistent or unknown.)
	 */
	public IncorrectFileExtensionException(Throwable cause) {
		super();
		initCause(cause);
	}

	/**
	 * <p>
	 * Constructs an <code>IncorrectFileExtensionException</code> with the
	 * specified detail message and cause.
	 * </p>
	 * 
	 * <p>
	 * Note that the detail message associated with <code>cause</code> is
	 * <i>not</i> automatically incorporated into this exception's detail
	 * message.
	 * </p>
	 * 
	 * @param message
	 *            The detail message (which is saved for later retrieval by the
	 *            <code>Throwable.getMessage()</code> method)
	 * @param cause
	 *            The cause (which is saved for later retrieval by the
	 *            <code>Throwable.getCause()</code> method). (A
	 *            <code>null</code> value is permitted, and indicates that the
	 *            cause is nonexistent or unknown.)
	 */
	public IncorrectFileExtensionException(String message, Throwable cause) {
		super(message);
		initCause(cause);
	}
}