package comp202.fall2007.a5.util.file;

import java.io.File;
import java.io.FileFilter;

public class ExtensionFileFilter implements FileFilter {
	private String extension;

	public ExtensionFileFilter(String extension) {
		this.extension = extension;
	}

	public String getExtension() {
		return this.extension;
	}

	public boolean accept(File pathname) {
		boolean result;
		String fileName;
		int lastDot;

		result = false;
		if (pathname.exists() && !pathname.isDirectory()) {
			fileName = pathname.getName();
			lastDot = fileName.lastIndexOf('.');
			if (lastDot != -1) {
				result = this.extension.equalsIgnoreCase(fileName
						.substring(lastDot));
			}
		}
		return result;
	}
}
